<?php
/*
Plugin Name: Multiple Category Selection Widget
Plugin URI: http://www.zackdesign.biz/mcsw
Description: Select multiple categories at once using this widget!
Author: Isaac Rowntree
Version: 2.1
Author URI: http://zackdesign.biz

	Copyright (c) 2005, 2006 Isaac Rowntree (http://zackdesign.biz)
	QuickShop is released under the GNU General Public
	License (GPL) http://www.gnu.org/licenses/gpl.txt

	This is a WordPress plugin (http://wordpress.org).

*/

$wpmm_cats = 0;
$wpmm_search_vars = 0;

function wpmm_load_category()
{
    if (!empty($_POST['wpmm']))
    {        
        $cats = $_POST['wpmm'];
        
        $sql = '';
	$count = 0;
        foreach ($cats as $cat)
        {
            if ($cat == 0)
                unset($cats[$count]);
            else
                $sql .= $cat.',';
            $count++;
	}
        $sql = trim ($sql, ',');
        if (!empty($sql))
        {
          if (get_option('permalink_structure')!= '')
          {
              wp_redirect(get_bloginfo('url').'/categories/'.$sql.'/search_type/'.$_POST['mmctype']);
		          exit();
		      }
		      else
		      {
              wp_redirect(get_bloginfo('url').'/?cat='.$sql.'&search_type='.$_POST['mmctype']);
		          exit();
          }
        }
    }
    
   global $wp_rewrite;
   $wp_rewrite->flush_rules();
}


function categories_queryvars( $qvars )
{
  $qvars[] = 'search_type';
  return $qvars;
}

function wpmm_parse($vars)
{
    if (!empty($vars->query_vars['search_type']))
    {
         $cats = explode(',',$vars->query_vars['cat']);
	 $type = $vars->query_vars['search_type'];
    
        global $wp;
        $wp->set_query_var('category__'.$type, $cats);
    
        global $wpmm_cats;
        global $wpmm_search_vars;
    
        $wpmm_cats = $vars->query_vars['cat'];
	
        $wpmm_search_vars = $type;
    }
}

function wpmm_add_rewrite_rules( $wp_rewrite ) 
{
  $new_rules = array( 
     'categories/(.+)/search_type/(.+)/page/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1).'&search_type=' . $wp_rewrite->preg_index(2).'&paged='. $wp_rewrite->preg_index(3),
     'categories/(.+)/search_type/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1).'&search_type=' . $wp_rewrite->preg_index(2),
     'categories/(.+)/page/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1).'&paged=' . $wp_rewrite->preg_index(2),
     'categories/(.+)' => 'index.php?cat=' .
       $wp_rewrite->preg_index(1));
  
  $wp_rewrite->rules = $new_rules + $wp_rewrite->rules;
}

// Get Wordpress to parse URL for query categories
add_filter('query_vars', 'categories_queryvars' );

// Run the category selection
add_action('parse_request','wpmm_parse');

// Rewrite URL
add_action('init','wpmm_load_category');
add_action('generate_rewrite_rules', 'wpmm_add_rewrite_rules');

add_action('widgets_init', create_function('', 'return register_widget("MCSWwidget");'));

/**
 * wpmm widget Class
 */
class MCSWwidget extends WP_Widget {
    /** constructor */
    function MCSWwidget() {
        parent::WP_Widget(false, $name = 'Multi-Category');	
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {	
    
    extract( $args );
    $title = apply_filters('widget_title', $instance['title']);   
    global $wpdb;
    global $wpmm_cats;
    global $wpmm_search_vars;
                                   
    $categories = get_categories('orderby=name&hide_empty=1&exclude=1,'.$instance['excluded_cats']);
    
    $parents = array();
    $children = array();
    
    foreach ($categories as $cat)
    {
        if (!$cat->parent)
            $parents[] = $cat;
        else
            $children[] = $cat;
    }
    
    echo $before_widget;
    echo $before_title . $title . $after_title .'
    
    <form action="" method="post" id="wpmm">
    
    ';
    
    foreach ($parents as $p)
    {
        echo '
        <select name="wpmm[]">
        <option value="0">'.apply_filters('single_cat_title', stripslashes(str_replace('"', '', $p->name))).'</option>';
        
        foreach ($children as $c)
        {
            $selected = '';
            
            if (!empty($wpmm_cats))
            {
                $cats = explode(',', $wpmm_cats);
                
                foreach ($cats as $cat)
                {
                    if ($cat == $c->cat_ID)
                        $selected = 'selected="selected"';
                }
            }
            
            if ($p->cat_ID == $c->parent)
                echo '<option '.$selected.' value="'.$c->cat_ID.'"> '.apply_filters('single_cat_title', stripslashes(str_replace('"', '', $c->name))).'</option>';
        }
        
        echo '</select>';
    }
    
    $checked1 = '';
    $checked2 = '';
        
    if ($wpmm_search_vars == 'and')
        $checked2 = 'checked="checked"';
    else if ($wpmm_search_vars == 'in')
        $checked1 = 'checked="checked"';
    else if (strcmp($instance['def_search_type'], 'in'))
        $checked1 = 'checked="checked"';
    else
        $checked2 = 'checked="checked"';

        if ($instance['user_choice'])
        {    
            echo '<br />Any <input type="radio" name="mmctype" value="in" '.$checked1.'> All <input type="radio" name="mmctype" value="and" '.$checked2.'>
            <input type="submit" value="Search"></form>'.$after_widget;
        }
	else
	{ 
	    echo '<input type="hidden" name="mmctype" value="'.$instance['def_search_type'].'">
            <input type="submit" value="Search"></form>'.$after_widget;
	}
    }

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
        return $new_instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
        $title = esc_attr($instance['title']);
	$excluded_cats = esc_attr($instance['excluded_cats']);
	
	$def_search_type = esc_attr($instance['def_search_type']);	
	if ($def_search_type == 'in')
	    $def_search_type_in = 'checked="checked"';
	else
	    $def_search_type_and = 'checked="checked"';
	    
	$user_choice = esc_attr($instance['user_choice']);
	if ($user_choice)
	    $user_choice_checked = 'checked="checked"';
        ?>
            <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
	    <p><label for="<?php echo $this->get_field_id('excluded_cats'); ?>"><?php _e('Comma Seperated Excluded Category IDs:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('excluded_cats'); ?>" name="<?php echo $this->get_field_name('excluded_cats'); ?>" type="text" value="<?php echo $excluded_cats; ?>" /></label></p>
	    <p><label for="<?php echo $this->get_field_id('user_choice'); ?>"><?php _e('User Chooses Search Type:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('user_choice'); ?>" name="<?php echo $this->get_field_name('user_choice'); ?>" type="checkbox" <?php echo $user_choice_checked; ?> /></label></p>
	    <p><label for="<?php echo $this->get_field_id('def_search_type'); ?>"><?php _e('Default Search Type:'); ?></label> <?php _e('All'); ?> <input class="widefat" id="<?php echo $this->get_field_id('def_search_type'); ?>" name="<?php echo $this->get_field_name('def_search_type'); ?>" type="radio" value="and" <?php echo $def_search_type_and; ?> /> <?php _e('Any'); ?> <input class="widefat" id="<?php echo $this->get_field_id('def_search_type'); ?>" name="<?php echo $this->get_field_name('def_search_type'); ?>" type="radio" value="in"  <?php echo $def_search_type_in; ?> /></p>
        <?php 
    }

} // class MCSWwidget


?>